<!doctype html>
<html lang="en" xmlns:th="http://www.thymeleaf.org">
<head>
    <base th:href="${#request.getContextPath() + '/'} ">
    <meta charset="utf-8">
    <meta name="renderer" content="webkit">
    <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, minimum-scale=1.0, maximum-scale=1.0, user-scalable=0">
    <link rel="stylesheet" href="assets/fonts/font-awesome/css/font-awesome.css"/>
    <link rel="stylesheet" type="text/css" href="assets/js/vendor/viewer/viewer.min.css">
    <link rel="stylesheet" href="assets/layuiadmin/layui/css/layui.css" media="all">
    <link rel="stylesheet" href="assets/layuiadmin/style/admin.css" media="all">
</head>
<body>
<div class="layui-fluid layui-anim layui-anim-fadein" style="padding: 0px;">
    <div class="layui-row">
        <div class="layui-col-md12">
            <div class="layui-card">
                <div class="layui-card-body">
                    <div class="test-table-reload-btn" style="margin-bottom: 10px;">
                        <div class="layui-inline">
                            <input type="text" id="keywords" class="layui-input search-item" placeholder="输入关键字">
                        </div>
                        <div class="layui-inline">
                            <input type="text" id="startTime" class="layui-input search-item" placeholder="开始时间" readonly>
                        </div>
                        <div class="layui-inline">
                            <input type="text" id="endTime" class="layui-input search-item" placeholder="结束时间" readonly>
                        </div>
                        <button type="button" id="search" class="layui-btn layui-btn-sm">
                            <i class="fa fa-lg fa-search"></i> 搜索
                        </button>
                    </div>
                    <form class="layui-form layui-form-pane" lay-filter="tableForm">
                        <table class="layui-hide" id="dataTable" lay-filter="dataTable"></table>
                    </form>
                    <!-- 表头按钮组 -->
                    <script type="text/html" id="headerToolBar">
                        <div class="layui-btn-group">
                            <button type="button" class="layui-btn layui-btn-sm" lay-event="saveEvent">
                                <i class="fa fa-lg fa-plus"></i> 新增
                            </button>
                            <button type="button" class="layui-btn layui-btn-normal layui-btn-sm" lay-event="updateEvent">
                                <i class="fa fa-lg fa-edit"></i> 编辑
                            </button>
                            <button type="button" class="layui-btn layui-btn-danger layui-btn-sm" lay-event="removeEvent">
                                <i class="fa fa-lg fa-trash"></i> 删除
                            </button>
                        </div>
                    </script>
                </div>
            </div>
        </div>
    </div>
</div>
<input type="hidden" id="tableName" th:value="${tableName}"/>
<script src="assets/layuiadmin/layui/layui.js"></script>
<script src="assets/js/vendor/viewer/viewer.min.js"></script>
<script>
    layui.config({
        base: 'assets/layuiadmin/'
    }).extend({
        index: 'lib/index'
    }).use(['index', 'table', 'form', 'laydate'], function() {
        var $ = layui.$;
        var $win = $(window);
        var table = layui.table;
        var admin = layui.admin;
        var form = layui.form;
        var laydate = layui.laydate;
        var resizeTimeout = null;

        // 初始化表格
        function initTable() {
            table.render({
                elem: '#dataTable',
                id: 'dataTable',
                url: top.restAjax.path('api/dynamicconfigtable/dynamicconfigform/listpageform/{tableName}', [$('#tableName').val()]),
                width: admin.screen() > 1 ? '100%' : '',
                height: $win.height() - 60,
                limit: 20,
                limits: [20, 40, 60, 80, 100, 200],
                toolbar: '#headerToolBar',
                request: {
                    pageName: 'page',
                    limitName: 'rows'
                },
                cols: [
                    [
                        {type:'checkbox', fixed: 'left'},
                        {field:'rowNum', width:80, title: '序号', fixed: 'left', align:'center', templet: '<span>{{d.LAY_INDEX}}</span>'},
                        {field:'fieldName', width:120, title: '字段名称', align:'center', fixed: 'left'},
                        {field:'fieldExplain', width: 160, title: '字段说明', align:'center'},
                        {field:'fieldType', width:100, title: '字段类型', align:'center',
                            templet: function(row) {
                                var value;
                                switch (row.fieldType) {
                                    case 'datetime':
                                        value = '时间戳';
                                        break;
                                    case 'date':
                                        value = '日期';
                                        break;
                                    case 'number':
                                        value = '整形';
                                        break;
                                    case 'double':
                                        value = '双精度';
                                        break;
                                    case 'textarea':
                                        value = '文本域';
                                        break;
                                    case 'richText':
                                        value = '富文本';
                                        break;
                                    case 'select':
                                        value = '下拉选择';
                                        break;
                                    case 'checkbox':
                                        value = '复选';
                                        break;
                                    case 'radio':
                                        value = '单选';
                                        break;
                                    case 'selectUser':
                                        value = '选择人员';
                                        break;
                                    case 'selectDepartment':
                                        value = '选择部门';
                                        break;
                                    case 'file':
                                        value = '文件';
                                        break;
                                    case 'join':
                                        value = '主联字段';
                                        break;
                                    case 'currentUser':
                                        value = '当前用户';
                                        break;
                                    case 'currentDepartment':
                                        value = '当前组织';
                                        break;
                                    case 'currentRole':
                                        value = '当前角色';
                                        break;
                                    case 'currentGroup':
                                        value = '当前组';
                                        break;
                                    case 'currentPosition':
                                        value = '当前职位';
                                        break;
                                    case 'leftJoin':
                                        value = '左联表';
                                        break;
                                    case 'innerJoin':
                                        value = '内联表';
                                        break;
                                    case 'rightJoin':
                                        value = '右联表';
                                        break;
                                    default:
                                        value = '文本';
                                }
                                return value;
                            }
                        },
                        {field:'fieldDefault', width:140, title: '字段默认值', align:'center'},
                        {field:'dictionaryName', width:140, title: '字典名称', align:'center'},
                        {field:'verifyType', width:100, title: '校验类型', align:'center',
                            templet: function(row) {
                                var value;
                                switch (row.verifyType) {
                                    case 'required':
                                        value = '不为空'
                                        break;
                                    case 'phone':
                                        value = '手机号'
                                        break;
                                    case 'email':
                                        value = '邮件'
                                        break;
                                    case 'url':
                                        value = '链接'
                                        break;
                                    case 'number':
                                        value = '数字'
                                        break;
                                    case 'date':
                                        value = '日期'
                                        break;
                                    case 'identity':
                                        value = '身份证'
                                        break;
                                    case 'custom':
                                        value = '自定义'
                                        break;
                                    default:
                                        value = '无';
                                }
                                return value;
                            }
                        },
                        {field:'verifyRegular', width:140, title: '校验正则', align:'center'},
                        {field:'fieldSort', width:80, title: '排序', align:'center'},
                        {field:'listShowWidth', width:100, title: '列表宽度', align:'center'},
                        {field:'listShow', width:100, title: '列表显示', align:'center', fixed: 'right',
                            templet: function(row) {
                                if(row.listShow == 1) {
                                    return '<input type="checkbox" data-id="'+ row.id +'" lay-filter="listShow" lay-skin="switch" lay-text="开启|关闭" checked>';
                                }
                                return '<input type="checkbox" data-id="'+ row.id +'" lay-filter="listShow" lay-skin="switch" lay-text="开启|关闭">';
                            }
                        },
                        {field:'formShow', width:100, title: '表单显示', align:'center', fixed: 'right',
                            templet: function(row) {
                                if(row.formShow == 1) {
                                    return '<input type="checkbox" data-id="'+ row.id +'" lay-filter="formShow" lay-skin="switch" lay-text="开启|关闭" checked>';
                                }
                                return '<input type="checkbox" data-id="'+ row.id +'" lay-filter="formShow" lay-skin="switch" lay-text="开启|关闭">';
                            }
                        },
                    ]
                ],
                page: true,
                parseData: function(data) {
                    return {
                        'code': 0,
                        'msg': '',
                        'count': data.total,
                        'data': data.rows
                    };
                }
            });
        }
        // 重载表格
        function reloadTable() {
            table.reload('dataTable', {
                url: top.restAjax.path('api/dynamicconfigtable/dynamicconfigform/listpageform/{tableName}', [$('#tableName').val()]),
                where: {
                    keywords: $('#keywords').val(),
                    startTime: $('#startTime').val(),
                    endTime: $('#endTime').val()
                },
                height: $win.height() - 60,
            });
        }
        // 初始化日期
        function initDate() {
            // 日期选择
            laydate.render({
                elem: '#startTime',
                format: 'yyyy-MM-dd'
            });
            laydate.render({
                elem: '#endTime',
                format: 'yyyy-MM-dd'
            });
        }
        // 删除
        function removeData(ids) {
            top.dialog.msg(top.dataMessage.delete, {
                time: 0,
                btn: [top.dataMessage.button.yes, top.dataMessage.button.no],
                shade: 0.3,
                yes: function (index) {
                    top.dialog.close(index);
                    var layIndex;
                    top.restAjax.delete(top.restAjax.path('api/dynamicconfigtable/dynamicconfigform/removeform/{ids}', [ids]), {}, null, function (code, data) {
                        top.dialog.msg(top.dataMessage.deleteSuccess, {time: 1000}, function () {
                            reloadTable();
                        });
                    }, function (code, data) {
                        top.dialog.msg(data.msg);
                    }, function () {
                        layIndex = top.dialog.msg(top.dataMessage.deleting, {icon: 16, time: 0, shade: 0.3});
                    }, function () {
                        top.dialog.close(layIndex);
                    });
                }
            });
        }
        initTable();
        initDate();
        // 事件 - 页面变化
        $win.on('resize', function() {
            clearTimeout(resizeTimeout);
            resizeTimeout = setTimeout(function() {
                reloadTable();
            }, 500);
        });
        // 事件 - 搜索
        $(document).on('click', '#search', function() {
            reloadTable();
        });
        // 事件 - 增删改
        table.on('toolbar(dataTable)', function(obj) {
            var layEvent = obj.event;
            var checkStatus = table.checkStatus('dataTable');
            var checkDatas = checkStatus.data;
            if(layEvent === 'saveEvent') {
                layer.open({
                    type: 2,
                    title: false,
                    closeBtn: 0,
                    area: ['100%', '100%'],
                    shadeClose: true,
                    anim: 2,
                    content: top.restAjax.path('route/dynamicconfigtable/dynamicconfigform/save/{tableName}', [$('#tableName').val()]),
                    end: function() {
                        reloadTable();
                    }
                });
            } else if(layEvent === 'updateEvent') {
                if(checkDatas.length === 0) {
                    top.dialog.msg(top.dataMessage.table.selectEdit);
                } else if(checkDatas.length > 1) {
                    top.dialog.msg(top.dataMessage.table.selectOneEdit);
                } else {
                    layer.open({
                        type: 2,
                        title: false,
                        closeBtn: 0,
                        area: ['100%', '100%'],
                        shadeClose: true,
                        anim: 2,
                        content: top.restAjax.path('route/dynamicconfigtable/dynamicconfigform/update/{id}', [checkDatas[0].id]),
                        end: function() {
                            reloadTable();
                        }
                    });
                }
            } else if(layEvent === 'removeEvent') {
                if(checkDatas.length === 0) {
                    top.dialog.msg(top.dataMessage.table.selectDelete);
                } else {
                    var ids = '';
                    for(var i = 0, item; item = checkDatas[i++];) {
                        if(i > 1) {
                            ids += '_';
                        }
                        ids += item.id;
                    }
                    removeData(ids);
                }
            }
        });
        form.on('switch(listShow)', function(data) {
            top.restAjax.put(top.restAjax.path('api/dynamicconfigtable/dynamicconfigform/updatefieldlistshow/{id}', [this.dataset.id]), {
                show: data.elem.checked
            }, null, function(code, data) {
                top.dialog.msg('修改成功');
            }, function(code, data) {
                top.dialog.msg(data.msg);
            });
        });
        form.on('switch(formShow)', function(data) {
            top.restAjax.put(top.restAjax.path('api/dynamicconfigtable/dynamicconfigform/updatefieldformshow/{id}', [this.dataset.id]), {
                show: data.elem.checked
            }, null, function(code, data) {
                top.dialog.msg('修改成功');
            }, function(code, data) {
                top.dialog.msg(data.msg);
            });
        });
    });
</script>
</body>
</html>